/** Store information about the ball.
 * The information included, the placement of the ball, current velocity and direction, 
 * aswell as its size, point value and horisontal movement
 */


public class Ball {
	

//	private int alive;
	public WillPangImagePane imagePane;

	
	int ballSize = 0;
	int ballPxlSize = 0;
	int ballBounceSize;
	int ballPointValue;

	int x = 0;
	int y = 0;

	private int oldX = 0;
	private int oldY = 0;

	int lastX = -1;
	int lastY = -1;

	int s = 0;
	double v;
	double u;
	
	public double horDirection;
	private double scale;

	public boolean alive = true; 
		
//	private int alive;
	private double scaleBounceFactor;
//	private int type;

//	public Ball (int x, int y, int ballSize, int initialVelocity, int horDirection, double scaleBounceFactor) {
//		
//	}

	public BallType type;
	
	public Ball (int x, int y, int ballSize, int initialVelocity, double horDirection, int typeNo, WillPangImagePane imagePane) {
		

		type = imagePane.willPang.types[typeNo];
		this.scaleBounceFactor = scaleBounceFactor;
		this.imagePane = imagePane;
//		this.scale = scale;

		// Initialize all of the variables
		this.x = x;
		this.y = y;
		
		this.ballSize = ballSize;
	//	System.out.println("asdf");

		try {
			ballBounceSize = type.ballBounceSize[ballSize];
			ballPointValue = type.ballPointValue[ballSize];
			

			// Wait up to 1 second
			int timeout = 0;
			while (type.balls[ballSize].getWidth(null) == -1 && timeout < 5){
				Delegate.doze(200);
				timeout++;
			}
			//if (type.balls[ballSize].getWidth(null) == -1) {
			//	System.out.println("Warning: ball has incorrect pixel size, may bounce erroneously");
			//}

			ballPxlSize = type.balls[ballSize].getWidth(null);

		} catch (Exception e) {
			System.out.println("This ball uses an invalid ball size for this type.  Attempted Type: " + type.thisType + "  Attempted Size: " + ballSize);
			alive = false;

		}

		
		scale = imagePane.scale;
//		ballPxlSize = scaleAndRound(ballPxlSize);
		ballBounceSize = halfScaleAndRound(ballBounceSize);
		

	//	ballBounceSize = (int) Math.round(ballBounceSize * scaleBounceFactor);
		
		this.horDirection = horDirection;

		u = initialVelocity;
		alive = true;

	}
	
	
	
	public int getBallPxlSize () {
		return ballPxlSize;
	}
	
	public void update (int x, int y, double v, int s, int horDirection) {
		this.x = x;
		this.y = y;
		this.v = v;
		this.s = s;
		this.horDirection = horDirection;
	}
	
	public void remove() {
		remove(false);
	}
	public void remove(boolean force) {
	
		int w = type.balls[ballSize].getWidth(null);
		int h = w;
		
		if (((oldX != x || oldY != y) && oldX != -1) || force) imagePane.replaceRecta(imagePane.graphics,oldX,oldY,w,h);

	
	}

	public void draw () {
		//System.out.print("d");
		imagePane.graphics.drawImage(type.balls[ballSize], x, y,null);
		oldX = x;
		oldY = y;	
		
	}
	
	public void update (int horMovement, int time, int width, int height) {
		
		// If the ball didn't load properly, try again
		if (ballPxlSize == -1) {
			ballPxlSize = type.balls[ballSize].getWidth(null);
		}
	
//		int ballPxlSize = scaleAndRound(ballPxlSize);
//		int ballBounceSize = halfScaleAndRound(ballBounceSize);
	
	
	
		lastX = x;
		lastY = y;
				
		// bounce the ball (give it an upward velocity)
		if (y >= height - ballPxlSize) {
			s = 0; // reset the distance
			u = -ballBounceSize; // change velocity depending on the size of the ball

		}
				
		// increase the horisontal components
		x = (int) ( x + horMovement * horDirection);
		s++;

		// change the x direction if nessesary
		if (horDirection > 0 && x > width - ballPxlSize) horDirection = -horDirection;				
		if (horDirection < 0 && x < 0) horDirection = -horDirection;				

		//limit the x movement
		if (x < 0) 
			x = 0;
		if (x > width - ballPxlSize)
			x = width - ballPxlSize;
					
		
		double t = s * ((double) time / 1000);

		double a = BallLinked.a;


		// Calibrate the time to a frame rate of 1 every 200 milliseconds.
		// How this works:  The shorter the time, the more times the velocity is calculated, making it go higher.
		// To counter this, the gravity must increase also.  The balls were calibrated to 1/200, so anything smaller increases the gravity, and anthing larger decreases it
		// Note this doesn't fix the problem that the game seeds up with less wait.
		a = a * ((double) 200 / (double) time);

		v = u+a*t;
			
			
		// change the y coordinates
		y = y + (int) Math.round(v);
		
		u = v;
			
		//  if the ball is lower than the height, then set it to the lowest height
		if (y > height - ballPxlSize) y = height - ballPxlSize;
	}
	
	public void kill() {
		alive = false;
	}
	
	//Getter Methods
	public int getU () {
		return (int) u;
	}
	public int getX () {
		return x;
	}
	public int getLastX () {
		return lastX;
	}
	public int getY () {
		return y;
	}
	public int getLastY () {
		return lastY;
	}
	public double getV () {
		return v;
	}
	public int getS () {
		return s;
	}
	public double getHorDirection () {
		return horDirection;
	}	
	public int getBallSize () {
		return ballSize;
	}
	public int getBallPointValue() {
		return ballPointValue;
	}
	public String toString() {
		//public Ball (int x, int y, int ballSize, int initialVelocity, double horDirection, double scaleBounceFactor, int type, WillPangImagePane imagePane) {
		//
		return "ball:" + x + ":" + y + ":" + ballPxlSize + ":" + scaleBounceFactor;
	}

	public double getScaleBounceFactor () {
		return scaleBounceFactor;
	}
//	public ballTypeint getType () {
//		return type;
//	}


	public int scaleAndRound (int number) {
		return (int) Math.round(number * scale);
	}

	public int halfScaleAndRound (int number) {
		if (scale < 2) {
			return number;
		} else {
			return number + scaleAndRound(8)-8;//(int) Math.round(number * scale /2);
		}
	}

}
	
