; WillPang.nsi
;
; This script was adapted from example2.nsi that came with Nullsoft NSIS
;
; Edited by William Denniss

; The name of the installer
Name "WillPang Dev Studio 1.5.2b"

; The file to write
OutFile "WillPangDevStudio1.5.2b.exe"

;Set the installation icon
Icon ../../tsins.ico

;Set the uninstall icon
UninstallIcon ../../tsunins.ico

;Set Selected picture
EnabledBitmap ../../sel.bmp

;Set unselected picture
DisabledBitmap ../../unsel.bmp

;show the details while installing
ShowInstDetails show

LicenseText "You must agree to this license before you continue"
LicenseData ../../license.txt



; The default installation directory
InstallDir $PROGRAMFILES\TankSoftware\WillPang
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\WillPang "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This will install WillPang and the WillPang Config Editor. Please choose if you want shortcuts to be added to the start menu."
; The text to prompt the user to enter a directory
DirText "Choose where you want the program to be installed.  It is recommended that you don't change it from the default directory."

; The stuff to install
Section "WillPang Dev Studio (required)"

	MessageBox MB_OK "Please note:  The Java and Visual Basic 6 runtime files must be installed for this program to work correctly."


  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  ; Put file there
	File "BallGen1.2.2.jar"
	File "BallGen.wpbt"
	File "BallGen.bat"
	File "WillPangDevStudio1.5.2b(source).zip"
	File "WillPang - Ball Types.exe"
  File "WillPang - Config Editor.exe"
	File "WillPang - Level Maker.exe"
	File "WillPangBG.ico"
	File "WillPangCF.ico"
	File "WillPangLM.ico"
	File "WillPangBT.ico"

  SetOutPath $INSTDIR\images\balls
	File "images\balls\Ball-0-1.gif"
	File "images\balls\Ball-0-2.gif"
	File "images\balls\Ball-0-3.gif"
	File "images\balls\Ball-0-4.gif"
	File "images\balls\Ball-1-1.gif"
	File "images\balls\Ball-1-2.gif"
	File "images\balls\Ball-1-3.gif"
	File "images\balls\Ball-1-4.gif"
	File "images\balls\Ball-2-1.gif"
	File "images\balls\Ball-2-2.gif"
	File "images\balls\Ball-2-3.gif"
	File "images\balls\Ball-2-4.gif"
	File "images\balls\Ball-3-2.gif"
	File "images\balls\Ball-3-3.gif"

	;So working directory is correct
  SetOutPath $INSTDIR

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\WillPang "Install_Dir" "$INSTDIR"
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPangDev" "DisplayName" "Tank Software - WillPang Dev Studio(remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPangDev" "UninstallString" '"$INSTDIR\uninstall.exe"'
SectionEnd

; optional section
Section "Start Menu Shortcuts"
  CreateDirectory "$SMPROGRAMS\Tank Software\WillPang\Dev Studio"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\WillPang Ball Generator.lnk" "$INSTDIR\BallGen.bat" "" "$INSTDIR\WillPangBG.ico"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\WillPang Config Editor.lnk" "$INSTDIR\WillPang - Config Editor.exe" "" "$INSTDIR\WillPangCF.ico"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\WillPang Ball Types.lnk" "$INSTDIR\WillPang - Ball Types.exe" "" "$INSTDIR\WillPangBT.ico"
  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\WillPang Level Maker.lnk" "$INSTDIR\WillPang - Level Maker.exe" "" "$INSTDIR\WillPangLM.ico"

  CreateShortCut "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\Uninstall WillPang Dev Studio.lnk" "$INSTDIR\uninstalldev.exe" "" "$INSTDIR\uninstalldev.exe" 0
SectionEnd

; uninstall stuff

UninstallText "This will uninstall the WillPang Dev Studio. Hit next to continue."
UninstallExeName "uninstalldev.exe"

; special uninstall section.
Section "Uninstall"
	SetDetailsView show
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WillPangDev"
  ; remove files
	Delete "INSTDIR\BallGen1.2.2.jar"
	Delete "INSTDIR\BallGen.wpbt"
	Delete "INSTDIR\BallGen.bat"
	Delete "INSTDIR\WillPang - Ball Types.exe"
  Delete "INSTDIR\WillPang - Config Editor.exe"
	Delete "INSTDIR\WillPang - Level Maker.exe"
	Delete "INSTDIR\WillPangBG.ico"
	Delete "INSTDIR\WillPangCF.ico"
	Delete "INSTDIR\WillPangLM.ico"


  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe
  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Tank Software\WillPang\Dev Studio\*.*"
	RMDir "$SMPROGRAMS\Tank Software\WillPang\Dev Studio"

  ; remove directories used.
  RMDir "$INSTDIR"
SectionEnd

; eof
